new;
library pgraph;

let sigma  = 5.00	1.00	5.00	2.50	5.00	7.50	10.00;
let mu     = 5.00	1.00	5.00	2.50	5.00	7.50	10.00;

sharpe = mu ./ sigma;

mu = mu / 100;
sigma = sigma / 100;

n = rows(mu);
rho = eye(n);

cov = sigma .* sigma' .* rho;

Q = 2*cov;
R = mu;

A = 0; B = 0;
C = -ones(1,n); D = -1;
bounds = ones(n,1) .* (0~1);

sv = ones(n,1)/n;

Target_Vol = 1/100;

phi = Bisection(&diff_vol,0,1,1e-10);
{x,u1,u2,u3,u4,retcode} = QProg(sv,Q,phi*R,A,B,C,D,bounds);
er = x'mu;
vol = sqrt(x'cov*x);

print "Allocation = " 100*x;
print "Allocation non risque = " 100*(1-sumc(x));
print "Expected Return = " 100*er;
print "Volatility = " 100*vol;

proc diff_vol(phi);
  local x,u1,u2,u3,u4,retcode;
  local vol;

  {x,u1,u2,u3,u4,retcode} = QProg(sv,Q,phi*R,A,B,C,D,bounds);
  vol = sqrt(x'cov*x);

  retp(vol-Target_Vol);
endp;

proc Bisection(f,a,b,tol);
  local f:proc;
  local ya,yb,c,yc,e;

  ya = f(a); 
  yb = f(b);

  if ya*yb > 0;
    retp(error(0));
  endif;

  if ya == 0;
    retp(a);
  endif;

  if yb == 0;
    retp(b);
  endif;

  if ya < 0;
    do while maxc(abs(a-b)) > tol;
      c = (a+b)/2;
      yc = f(c);
      e = yc < 0;
      a = e*c + (1-e)*a;
      b = e*b + (1-e)*c;
    endo;
  else;
    do while maxc(abs(a-b)) > tol;
      c = (a+b)/2;
      yc = f(c);
      e = yc > 0;
      a = e*c + (1-e)*a;
      b = e*b + (1-e)*c;
    endo;
  endif;

  c = (a+b)/2;

  retp(c);
endp;
