new;
library pgraph;

cls;

varNames = SpreadSheetReadSA("cac.xls","a5:g5",1);
data     = SpreadSheetReadM("cac.xls","a7:g529",1);

indx_CAC = 2;
indx_TOTAL = 3;
indx_SANOFI = 4;
indx_SG = 5;
indx_FT = 6;
indx_DAX = 7;

P = data;
R = packr(ln(P) - lag(ln(P)));

R_Total = R[.,indx_Total];
R_SANOFI = R[.,indx_SANOFI];
R_SG = R[.,indx_SG];
R_CAC = R[.,indx_CAC];

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pcross = 1; _plctrl = -1; _pstype = 11;
  xy(100*R_Total,100*R_CAC);

T = rows(R_CAC);
X = ones(T,1)~R_CAC;
K = cols(X);
Y = R_SG;
coeffs = invpd(X'X)*X'Y;

alpha = coeffs[1];
beta = coeffs[2];

U = Y - X*coeffs;
TSS = sumc(Y^2);
RSS = sumc(U^2);
R2 = 1 - RSS/TSS;

print "R2 = " R2;

sigma = stdc(U);
covCoeffs = sigma^2 * invpd(X'X);
stdCoeffs = sqrt(diag(covCoeffs));
tstudent = (Coeffs - 0.0) ./ stdCoeffs;
pvalue = 2*cdftc(abs(tstudent),T-K);

print Coeffs~stdCoeffs~tstudent~pvalue;