new;
library optmum,pgraph;

#include regGMM.src

Nobs = 500;
x = 10*rndu(Nobs,4);
beta = rndn(4,1);
sigma = 2;
y = x*beta + rndn(Nobs,1)*sigma;

sv = beta|sigma; /* starting values */

proc H(theta);
  local beta,sigma,h1,M,i;

  M = zeros(Nobs,6);

  beta = theta[1:4];
  sigma = theta[5];

  /* first moment */
  h1 = y - x*beta;
  M[.,1] = h1;
  /* second moment */
  M[.,2] = h1.*h1 - sigma^2;

  i = 1;
  do until i > 4;
    M[.,2+i] = h1.*x[.,i];
    i = i + 1;
  endo;

  retp(M);
endp;

{theta,stderr,Mcov,Qmin} = regGMM(&h,sv,0,0);

ols = y/x;
u = y-x*ols;
ols = ols | stdc(u);

print sv~theta~ols;