new;
library tsm,optmum,pgraph;
TSMset;

m = 5;
sigma = 1;
x = m + rndn(1000,1)*sigma;
z = exp(x);

proc H(theta);
  local beta,m,sigma,h1,h2;

  m = theta[1];
  sigma = sqrt(theta[2]^2);

  /* first moment E[z] = exp(m+0.5*sigma^2) */
  h1 = z - exp(m+0.5*sigma^2);

  /* second moment var[z] = exp(2*m+sigma^2)*(exp(sigma^2)-1) */
  h2 = h1.*h1 - exp(2*m+sigma^2)*(exp(sigma^2)-1);

  retp(h1~h2);
endp;

output file = gmm4h.out reset;

_gmm_Jacobian_proc = 0;
sv = 1|1;
_gmm_lags = 0;
__output = 0;
_tsm_parnm = "m"|"sigma";

{theta,stderr,Mcov,Qmin} = gmm(&H,sv);

str = ftos(m,"True values --- m = %lf",3,2);
str = str $+ ftos(sigma," and sigma = %lf",3,2);
print str;

